import es
import gamethread, random, usermsg
import cfglib, cmdlib, playerlib, weaponlib

import psyco
psyco.full()

info = es.AddonInfo()
info.name = 'Nakama Random Perks Mod'
info.version = 'B_1.00.010'
info.url = 'http://forum.nakamagaming.com/'
info.basename = 'nakama_random_perks'
info.author = 'CrAzD'

es.ServerVar(info.basename, info.version, info.name).makepublic()


#######################
# CFG Directory Setup #
 #####################
directory = str(es.ServerVar("eventscripts_gamedir"))
cfg_directory = directory + "/cfg/Nakama/"
db_directory = cfg_directory + "DataBases/"


#########################
# Random Perks Settings #
 #######################
Perks_cfg = cfglib.AddonCFG(cfg_directory + "Perks.cfg")

# Global Settings #
    #Main
Nak_Perks_lock_teams = Perks_cfg.cvar(
                                                    'Nak_Perks_lock_teams',
                                                    1,
                                                    '1 = Both Teams, 2 = Ts only, 3 = CTs only \n// Lock teams out from using the perks system.')
    #Time
Nak_Perks_time_before_first_perk = Perks_cfg.cvar(
                                                    'Nak_Perks_time_before_first_perk',
                                                    5.0,
                                                    'How long to wait before giving the player their first perk, in seconds.')
Nak_Perks_time_between_perks_min = Perks_cfg.cvar(
                                                    'Nak_Perks_time_between_perks_min',
                                                    20.0,
                                                    'Minimum amount of time between perks, in seconds.')
Nak_Perks_time_between_perks_max = Perks_cfg.cvar(
                                                    'Nak_Perks_time_between_perks_max',
                                                    30.0,
                                                    'Maximum amount of time between perks, in seconds.')


# Perk Settings #
    #Speed
Nak_Perks_speed_on = Perks_cfg.cvar(
                                                    'Nak_Perks_speed_on',
                                                    1,
                                                    'Enable the Speed Module')
Nak_Perks_speed = Perks_cfg.cvar(
                                                    'Nak_Perks_speed',
                                                    1.5,
                                                    'How fast you want players to run when they are given the speed perk.')
Nak_Perks_speed_duration = Perks_cfg.cvar(
                                                    'Nak_Perks_speed_duration',
                                                    60.0,
                                                    'Duration of the Speed Perk, in seconds.')
Nak_Perks_speed_sound = Perks_cfg.cvar(
                                                    'Nak_Perks_speed_sound',
                                                    'Perks/superspeed.mp3',
                                                    'Sound to play to the player for the speed perk.')
    #God Mode
Nak_Perks_god_mode = Perks_cfg.cvar(
                                                    'Nak_Perks_god_mode',
                                                    1,
                                                    'Enables the god mod perk.')
Nak_Perks_god_mode_duration = Perks_cfg.cvar(
                                                    'Nak_Perks_god_mode_duration',
                                                    25.0,
                                                    'Duration of the god mode perk, in seconds.')
Nak_Perks_god_mode_sound = Perks_cfg.cvar(
                                                    'Nak_Perks_god_mode_sound',
                                                    'Perks/Indestructible.mp3',
                                                    'Sound to play to the player for the god mode perk.')
    #No Reload
Nak_Perks_no_reload = Perks_cfg.cvar(
                                                    'Nak_Perks_no_reload',
                                                    1,
                                                    'Enable the no reload perk.')
Nak_Perks_no_reload_duration = Perks_cfg.cvar(
                                                    'Nak_Perks_no_reload_duration',
                                                    45.0,
                                                    'Duration of the no reload perk, in seconds.')
Nak_Perks_no_reload_sound = Perks_cfg.cvar(
                                                    'Nak_Perks_no_reload_sound',
                                                    'Perks/maxammo.mp3',
                                                    'Sound to play to the player for the no reload perk.')
    #Invisibility
Nak_Perks_invisibility = Perks_cfg.cvar(
                                                    'Nak_Perks_invisibility',
                                                    1,
                                                    'Enable invisibility.')
Nak_Perks_invisibility_duration = Perks_cfg.cvar(
                                                    'Nak_Perks_invisibility_duration',
                                                    30.0,
                                                    'Duration of invisibility perk, in seconds.')
Nak_Perks_invisibility_sound = Perks_cfg.cvar(
                                                    'Nak_Perks_invisibility_sound',
                                                    'Perks/Invisible.mp3',
                                                    'Sound to play to the player for the invisibility perk.')
    #Instant Kills
Nak_Perks_instant_kills = Perks_cfg.cvar(
                                                    'Nak_Perks_instant_kills',
                                                    1,
                                                    'Enable instant kills.')
Nak_Perks_instant_kills_duration = Perks_cfg.cvar(
                                                    'Nak_Perks_instant_kills_duration',
                                                    35.0,
                                                    'Duration of instant kills perk, in seconds.')
Nak_Perks_instant_kills_sound = Perks_cfg.cvar(
                                                    'Nak_Perks_instant_kills_sound',
                                                    'Perks/instakill.mp3',
                                                    'Sound to play to the player for the instant kill perk.')

Perks_cfg.write()

###########
# GLOBALS #
 #########
Nak_Perks_DB = {}
Nak_Perks_roll_list = []
Nak_Perks_duration_list = []
Nak_Perks_max_duration_time = 0
Nak_Perks_weaponList = []
Nak_Perks_weaponList.append(weaponlib.getWeaponList('#primary'))
Nak_Perks_weaponList.append(weaponlib.getWeaponList('#secondary'))


def downloads():
    es.server.queuecmd('downloadable %s'%(Nak_Perks_speed_sound))
    es.server.queuecmd('downloadable %s'%(Nak_Perks_god_mode_sound))
    es.server.queuecmd('downloadable %s'%(Nak_Perks_no_reload_sound))
    es.server.queuecmd('downloadable %s'%(Nak_Perks_invisibility_sound))
    es.server.queuecmd('downloadable %s'%(Nak_Perks_instant_kills_sound))


def es_map_start(event_var):
    downloads()
    Perks_cfg.execute()
    
    global Nak_Perks_DB
    del Nak_Perks_DB
    Nak_Perks_DB = {}


def round_start(event_var):
    global Nak_Perks_roll_list, Nak_Perks_duration_list, Nak_Perks_max_duration_time
    del Nak_Perks_roll_list
    Nak_Perks_roll_list = []
    del Nak_Perks_duration_list
    Nak_Perks_duration_list = []
    max_duration_time = 0
    if Nak_Perks_speed_on:
        Nak_Perks_roll_list.append('speed')
        Nak_Perks_duration_list.append(int(Nak_Perks_speed_duration))
    if Nak_Perks_god_mode:
        Nak_Perks_roll_list.append('god')
        Nak_Perks_duration_list.append(int(Nak_Perks_god_mode_duration))
    if Nak_Perks_no_reload:
        Nak_Perks_roll_list.append('reload')
        Nak_Perks_duration_list.append(int(Nak_Perks_no_reload_duration))
    if Nak_Perks_invisibility:
        Nak_Perks_roll_list.append('invis')
        Nak_Perks_duration_list.append(int(Nak_Perks_invisibility_duration))
    if Nak_Perks_instant_kills:
        Nak_Perks_roll_list.append('instant')
        Nak_Perks_duration_list.append(int(Nak_Perks_instant_kills_duration))
    for time in Nak_Perks_duration_list:
        if time > Nak_Perks_max_duration_time:
            Nak_Perks_max_duration_time = time
    for player in es.getUseridList():
        id_user = es.getuserid(player)  
        perks_disable_scanner(id_user, playerlib.getPlayer(id_user), playerlib.uniqueid(id_user, True))


def player_spawn(event_var):
    id_user = event_var['userid']
    id_steam = playerlib.uniqueid(id_user, True)
    playerlib.getPlayer(id_user).setColor(255, 255, 255, 255)
    if not Nak_Perks_DB.has_key(id_steam):
        Nak_Perks_DB[id_steam] = {}
        Nak_Perks_DB[id_steam]['speed'] = 0
        Nak_Perks_DB[id_steam]['god'] = 0
        Nak_Perks_DB[id_steam]['reload'] = 0
        Nak_Perks_DB[id_steam]['invisible'] = 0
        Nak_Perks_DB[id_steam]['instant'] = 0
    if Nak_Perks_lock_teams != 1:
        if es.getplayerteam(id_user) != Nak_Perks_lock_teams:
            return
    id_delay = (float(Nak_Perks_time_before_first_perk) * 1.0)
    gamethread.cancelDelayed('perks_random_start_%s'%(id_user))
    gamethread.cancelDelayed('perks_random_continue_%s'%(id_user))
    gamethread.delayedname(id_delay, 'perks_random_start_%s'%(id_user), perks_random_start, (id_user, id_steam))
    gamethread.delayedname(id_delay, 'perks_random_continue_%s'%(id_user), perks_random_continue, (id_user, id_steam))


def player_death(event_var):
    id_user = event_var['userid']
    perks_disable_scanner(id_user, playerlib.getPlayer(id_user), playerlib.uniqueid(id_user, True))


def player_hurt(event_var):
    if not event_var['es_userdead']:
        return
    if Nak_Perks_DB[playerlib.uniqueid(event_var['attacker'], True)]['instant'] and not Nak_Perks_DB[playerlib.uniqueid(event_var['userid'], True)]['god']:
        id_user = event_var['userid']
        id_att_user = event_var['attacker']
        es.server.queuecmd('damage %s %s'%(id_user, int(event_var['health'])))
        es.server.queuecmd('score add %s %d'%(id_user, 1))
        es.server.queuecmd('score add %s %d'%(id_att_user, 1))
        es.tell(id_user, 'You have been insta killed by %s'%(es.getplayername(id_att_user)))
        es.tell(event_var['attacker'], 'You have insta killed %s'%(es.getplayername(id_user)))


def weapon_reload(event_var):
    id_user = event_var['userid']
    if Nak_Perks_DB[playerlib.uniqueid(id_user, True)]['reload']:
        id_weapon = event_var['es_userweapon']
        if id_weapon in Nak_Perks_weaponList[0] or id_weapon in Nak_Perks_weaponList[1]:
            id_player = playerlib.getPlayer(id_user)
            es.server.queuecmd('es_xremove %s'%(id_player.getWeaponIndex(id_weapon)))
            es.server.queuecmd('es_xgive %s %s'%(id_user, id_weapon))
            gamethread.delayed(1.0, id_player.setClip, (id_player.secondary, 250))
            gamethread.delayed(1.0, id_player.setClip, (id_player.primary, 250))


def player_death(event_var):
    perks_disable_scanner(event_var['userid'], playerlib.getPlayer(event_var['userid']), playerlib.uniqueid(event_var['userid'], True))


def perks_random_continue(id_user, id_steam):
    if not es.exists('userid', id_user):
        return
    id_delay = random.randrange(float(Nak_Perks_time_between_perks_min), Nak_Perks_time_between_perks_max)
    gamethread.cancelDelayed('perks_random_start_%s'%(id_user))
    gamethread.cancelDelayed('perks_random_continue_%s'%(id_user))
    gamethread.delayedname(id_delay, 'perks_random_start_%s'%(id_user), perks_random_start, (id_user, id_steam))
    gamethread.delayedname(id_delay, 'perks_random_continue_%s'%(id_user), perks_random_continue, (id_user, id_steam))


def perks_random_start(id_user, id_steam):
    if not es.exists('userid', id_user):
        return
    global Nak_Perks_DB
    id_player = playerlib.getPlayer(id_user)
    perks_disable_scanner(id_user, id_player, id_steam)
    choice = random.choice(Nak_Perks_roll_list)
    if choice == 'speed':
        Nak_Perks_DB[id_steam]['speed'] = 1
        es.setplayerprop(id_user, "CBasePlayer.localdata.m_flLaggedMovementValue", Nak_Perks_speed)
        gamethread.delayed(float(Nak_Perks_speed_duration * 1.0), perks_disable_speed, (id_user, id_steam))
        es.playsound(id_user, Nak_Perks_speed_sound, 1.0)
        perks_countdown(id_user, Nak_Perks_speed_duration, 'Super Speed')
        return
    if choice == 'god':
        if not id_player.attributes['isbot']:
            Nak_Perks_DB[id_steam]['god'] = 1
            es.setplayerprop(id_user, "CBasePlayer.m_iHealth", 99999)
            gamethread.delayed(float(Nak_Perks_god_mode_duration * 1.0), perks_disable_god_mode, (id_user, id_steam))
            es.playsound(id_user, Nak_Perks_god_mode_sound, 1.0)
            perks_countdown(id_user, Nak_Perks_god_mode_duration, 'God Mode')
            return
        choice = random.choice(Nak_Perks_roll_list)
    if choice == 'reload':
        Nak_Perks_DB[id_steam]['reload'] = 1
        perks_reload(id_player, id_steam)
        gamethread.delayed(float(Nak_Perks_no_reload_duration * 1.0), perks_disable_no_reload, (id_user, id_player, id_steam))
        es.playsound(id_user, Nak_Perks_no_reload_sound, 1.0)
        perks_countdown(id_user, Nak_Perks_no_reload_duration, 'No Reload')
        return
    if choice == 'invis':
        Nak_Perks_DB[id_steam]['invisible'] = 1
        id_player.setColor(255, 255, 255, 0)
        gamethread.delayed(float(Nak_Perks_invisibility_duration * 1.0), perks_disable_invisibility, (id_user, id_player, id_steam))
        es.playsound(id_user, Nak_Perks_invisibility_sound, 1.0)
        perks_countdown(id_user, Nak_Perks_invisibility_duration, 'Invisibility')
        return
    Nak_Perks_DB[id_steam]['instant'] = 1
    gamethread.delayed(float(Nak_Perks_instant_kills_duration * 1.0), perks_disable_instant_kill, (id_user, id_steam))
    es.playsound(id_user, Nak_Perks_instant_kills_sound, 1.0)
    perks_countdown(id_user, Nak_Perks_instant_kills_duration, 'Instant Kill')


def perks_disable_scanner(id_user, id_player, id_steam):
    if not es.exists('userid', id_user):
        return                                      
    perks_countdown_disable(id_user)
    if Nak_Perks_DB[id_steam]['speed']:
        perks_disable_speed(id_user, id_steam)
    if Nak_Perks_DB[id_steam]['god']:
        perks_disable_god_mode(id_user, id_steam)
    if Nak_Perks_DB[id_steam]['reload']:
        perks_disable_no_reload(id_user, id_player, id_steam)
    if Nak_Perks_DB[id_steam]['invisible']:
        perks_disable_invisibility(id_user, id_player, id_steam)
    if Nak_Perks_DB[id_steam]['instant']:
        perks_disable_instant_kill(id_user, id_steam) 
    perks_countdown_disable(id_user)


def perks_disable_speed(id_user, id_steam):
    global Nak_Perks_DB
    Nak_Perks_DB[id_steam]['speed'] = 0
    es.setplayerprop(id_user, "CBasePlayer.localdata.m_flLaggedMovementValue", 1.0)


def perks_disable_god_mode(id_user, id_steam):
    global Nak_Perks_DB
    Nak_Perks_DB[id_steam]['god'] = 0
    es.setplayerprop(id_user, "CBasePlayer.m_iHealth", 100)
    

def perks_disable_no_reload(id_user, id_player, id_steam):
    global Nak_Perks_DB
    Nak_Perks_DB[id_steam]['reload'] = 0
    try:
        id_player.setClip(id_player.primary, 8)
    except ValueError:
        pass
    try:
        id_player.setClip(id_player.secondary, 8)
    except ValueError:
        return


def perks_disable_invisibility(id_user, id_player, id_steam):
    global Nak_Perks_DB
    Nak_Perks_DB[id_steam]['invisible'] = 0
    id_player.setColor(255, 255, 255, 255)


def perks_disable_instant_kill(id_user, id_steam):
    global Nak_Perks_DB
    Nak_Perks_DB[id_steam]['instant'] = 0


def perks_countdown(id_user, time, name):
    i = 0
    n_time = int(time / 2)
    gamethread.cancelDelayed('usermsg_centermsg_continue_%s'%(id_user))
    gamethread.delayedname(float(float(n_time) * 1.0), 'usermsg_centermsg_continue_%s'%(id_user), perks_countdown_continue, (id_user, time, name))
    while i < n_time:
        gamethread.delayedname((float(i) * 1.0), 'usermsg_centermsg_%s_%d'%(id_user, i), usermsg.centermsg, (id_user, '%d seconds of %s.'%(time - i, name)))
        i += 1


def perks_countdown_continue(id_user, time, name):
    if not es.exists('userid', id_user):
        return
    i = 0
    n_time = int(time / 2)
    while i < n_time:
        gamethread.delayedname((float(i) * 1.0), 'usermsg_centermsg_%s_%d'%(id_user, int(i + n_time)), usermsg.centermsg, (id_user, '%d seconds of %s.'%(time - (i + n_time), name)))
        i += 1


def perks_countdown_disable(id_user):
    if not es.exists('userid', id_user):
        return
    i = 0
    while i < Nak_Perks_max_duration_time:
        gamethread.cancelDelayed('usermsg_centermsg_%s_%d'%(id_user, i))
        i += 1


def perks_reload(id_player, id_steam):
    if Nak_Perks_DB[id_steam]['reload']:
        gamethread.delayed(5.0, perks_reload, (id_player, id_steam))
        try:
            id_player.setClip(id_player.primary, 250)
        except ValueError:
            pass
        try:
            id_player.setClip(id_player.secondary, 250)
        except ValueError:
            return
